/* domme.h - an example header file
Copyright (C) 2022-2024 phantom (phantom@syslbnth.com)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>. */

#ifndef DOMME_H
#define DOMME_H

/* If you're interested in this library, you might find this handy.
Call it to trigger a segfault (in other words, to run domme on purpose).
It returns an int so that it can be used as the return value from main.
See "domme-test-driver.c" for a good reason for this to have at least one argument. */
#define CRASH ((int(*)(int))0)		/* good thing you don't have to define this yourself */

extern const int DOMME_version[];	/* can be used to deduce features */
extern const size_t DOMME_VERSION_SIZE;	/* number of numbers in the version number */
extern unsigned char DOMME_xlat_a[];	/* like a weighted encounter table */
extern const size_t DOMME_XLAT_A_SIZE;	/* size of xlat_a in bytes */
extern struct DOMME_msg {
  const char *msgptr;			/* must be a valid pointer */
  size_t msgsiz;			/* should be strlen(msgptr)-1 */
} DOMME_msgtbl[];			/* you can replace entries if you like */
extern const size_t DOMME_MSGTBL_SIZE;	/* number of messages in table above */
extern const size_t DOMME_NMSGS;	/* actual number of messages, excluding reserved ones */

/* Initialization for 'domme.' */
int DOMME_init(const void *sa, void *oldact, size_t sigsetsize);

/* The main attraction. */
void domme(int sig, void *info, void *ucontext);

#endif
